summaryrefslogtreecommitdiff
path: root/support
diff options
context:
space:
mode:
authorYann E. MORIN <yann.morin.1998@free.fr>2014-07-02 23:11:19 +0200
committerPeter Korsgaard <peter@korsgaard.com>2014-07-02 23:47:13 +0200
commit95a572282e871fdbf5caef2492793ab0fcc61882 (patch)
tree2951cf3a4ec523eb9ae70cdcfe177ed15ed3a911 /support
parent2d4fd5d358966b9959a0ea9f93daa3a08c6068e7 (diff)
pkg-infra: move the git download helper to a script
The git download helper is getting a bit more complex. Fixing it in the Makefile when it breaks (like the recent breakage with a non-existing sha1-cset) proves to be challenging, to say the least. Move it into a shell script in support/download/git, which will make it much easier to read, maintain, fix and enhance in the future. [Peter: redirect pushd/popd output to /dev/null] Signed-off-by: "Yann E. MORIN" <yann.morin.1998@free.fr> Cc: Peter Korsgaard <jacmet@uclibc.org> Cc: Thomas Petazzoni <thomas.petazzoni@free-electrons.com> Acked-by: Luca Ceresoli <luca@lucaceresoli.net> Cc: Arnout Vandecappelle <arnout@mind.be> Reviewed-by: Samuel Martin <s.martin49@gmail.com> Reviewed-by: Arnout Vandecappelle (Essensium/Mind) <arnout@mind.be> Signed-off-by: Peter Korsgaard <peter@korsgaard.com>
Diffstat (limited to 'support')
-rwxr-xr-xsupport/download/git37
1 files changed, 37 insertions, 0 deletions
diff --git a/support/download/git b/support/download/git
new file mode 100755
index 000000000..53970966b
--- /dev/null
+++ b/support/download/git
@@ -0,0 +1,37 @@
+#!/bin/bash
+
+# We want to catch any command failure, and exit immediately
+set -e
+
+# Download helper for git
+# Call it with:
+# $1: git repo
+# $2: git cset
+# $3: package's basename (eg. foobar-1.2.3)
+# $4: output file
+# And this environment:
+# BR2_DL_DIR: path to Buildroot's download dir
+# GIT : the git command to call
+
+repo="${1}"
+cset="${2}"
+basename="${3}"
+output="${4}"
+
+repodir="${BR2_DL_DIR}/${basename}"
+
+if [ -n "$(${GIT} ls-remote "${repo}" "${cset}" 2>&1)" ]; then
+ printf "Doing shallow clone\n"
+ ${GIT} clone --depth 1 -b "${cset}" --bare "${repo}" "${repodir}"
+else
+ printf "Doing full clone\n"
+ ${GIT} clone --bare "${repo}" "${repodir}"
+fi
+
+pushd "${repodir}" >/dev/null
+${GIT} archive --prefix="${basename}/" -o "${output}.tmp" --format=tar "${cset}"
+gzip -c "${output}.tmp" >"${output}"
+rm -f "${output}.tmp"
+popd >/dev/null
+
+rm -rf "${repodir}"